#
# Conditional build:
%bcond_without	tests		# build without tests

%define		php_name	php%{?php_suffix}
%define		modname	ds
Summary:	Data Structures
Name:		%{php_name}-pecl-%{modname}
Version:	1.2.9
Release:	3
License:	MIT
Group:		Development/Languages/PHP
Source0:	https://pecl.php.net/get/%{modname}-%{version}.tgz
# Source0-md5:	7e8bb1525c450e8e126a368e7ada4ab7
URL:		https://pecl.php.net/package/ds/
BuildRequires:	%{php_name}-cli
BuildRequires:	%{php_name}-devel >= 4:7.0
BuildRequires:	%{php_name}-json
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-spl
BuildRequires:	rpmbuild(macros) >= 1.666
%if %{with tests}
%endif
%{?requires_php_extension}
Requires:	%{php_name}-json
Requires:	%{php_name}-spl
Provides:	php(%{modname}) = %{version}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Data Structures for PHP 7.

%prep
%setup -qc
mv %{modname}-%{version}/* .

cat <<'EOF' > run-tests.sh
#!/bin/sh
export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
exec %{__make} test \
	PHP_EXECUTABLE=%{__php} \
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="pcre spl json" \
	RUN_TESTS_SETTINGS="-q $*"
EOF
chmod +x run-tests.sh

%build
phpize
%configure
%{__make}

# simple module load test
%{__php} -n -q \
	-d extension_dir=modules \
	-d extension=%{php_extensiondir}/pcre.so \
	-d extension=%{php_extensiondir}/spl.so \
	-d extension=%{php_extensiondir}/json.so \
	-d extension=%{modname}.so \
	-m > modules.log
grep %{modname} modules.log

%if %{with tests}
./run-tests.sh --show-diff
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
install -d $RPM_BUILD_ROOT{%{php_sysconfdir}/conf.d,%{php_extensiondir}}

%{__make} install \
	EXTENSION_DIR=%{php_extensiondir} \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
%if "%php_major_version.%php_minor_version" >= "7.4"
# order after ext-json
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/01_%{modname}.ini
%else
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/json_%{modname}.ini
%endif
; Enable %{modname} extension module
extension=%{modname}.so
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%files
%defattr(644,root,root,755)
%doc LICENSE
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/*%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so
%changelog
* Fri Oct 18 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-ds.git;a=log;h=master

* Thu Oct 17 2019 Elan Ruusamäe <glen@pld-linux.org> ea9bee7
- Use php 7.4 module load ordering

* Mon Sep 23 2019 Elan Ruusamäe <glen@delfi.ee> 427d051
- Rebuild with 7.4 RC2
- release 2 (by relup.sh)

* Sun Jun 23 2019 Elan Ruusamäe <glen@pld-linux.org> 6218196
- up to 1.2.9

* Sat Mar 30 2019 Jan Rękorajski <baggins@pld-linux.org> 9f82ebd
- rel 4

* Thu Mar 21 2019 Elan Ruusamäe <glen@pld-linux.org> 438d385
- load module after json module

* Mon Mar 11 2019 Elan Ruusamäe <glen@pld-linux.org> cb52586
- ext-pcre for i686

* Mon Mar 11 2019 Elan Ruusamäe <glen@pld-linux.org> 228ceb1
- new, version 1.2.8

